package maxflow;

import java.util.LinkedList;

class Vertex implements Comparable<Vertex> 
{
    String     name;   // Vertex name
    LinkedList<Edge> adj;    // Adjacent vertices
    public int        dist;   // Cost
    public boolean known;
    Vertex     path;   // Previous vertex on shortest path

    public Vertex( String nm )
      { name = nm; adj = new LinkedList<Edge>( ); reset( ); }

    public void reset( )
      { dist = Graph.INFINITY; path = null; }

	public int compareTo(Vertex w) {
		return (dist < w.dist) ? -1 : (dist == w.dist) ? 0 : 1;
	}    
}
